;function to read the project
LB_BuildGui(File, GuitoCreate = 0){
  If !GuitoCreate {
     IniRead, ListOfGuiID, %File%, Project, ListOfGuiID, %A_Space%
     Loop, Parse, ListOfGuiID, |, A_Space
         LB_ReadGui(File, A_LoopField)
  }Else
    LB_ReadGui(File, GuitoCreate)
}
  
;function to create a gui
LB_ReadGui(File, GuiID){
  Gui, %GuiID%: +LastFound
  LB_SetVarGlobal("Gui" GuiID "_HWND", WinExist())

  ;read global gui options (e.g. Margin) and react on them

  IniRead, ListOfCtrl, %File%, Gui %GuiNumber%, ListOfCtrl, %A_Space%
  Loop, Parse, ListOfCtrl, |, A_Space
      LB_ReadControl(File, GuiID, A_LoopField)

  ;read gui options and react on them
 
  ;show gui
  Items2Read = X|Y|W|H|AutoSize

  Loop, Parse, Items2Read, |
   IniRead, %A_LoopField%, %File%, Gui %GuiNumber%, %A_LoopField%, %A_Space%

  IniRead, Title, %File%, Gui %GuiNumber%, Title, Gui %GuiID%
  Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h
  Gui, %GuiID%:Show, %Pos% %AutoSize%, %Title%
}

;function to create a control
LB_ReadControl(File, GuiID, CtrlNumber){
  IniRead, Type, %File%, Control %CtrlNumber%, Type, %A_Space%
  If !Type
      MsgBox, Error, need Type
 
  ;read control options (e.g. Font) and react on them
  Items2Read = Type|VarName|GLabel|Content|Options|X|Y|W|H|R
 
  Loop, Parse, Items2Read, |
     IniRead, %A_LoopField%, %File%, Control %CtrlNumber%, %A_LoopField%, %A_Space%

  Pos := ( x ? " x" : "") x ( y ? " y" : "") y ( w ? " w" : "") w ( h ? " h" : "") h ( r ? " r" : "") r
  Options .= ( VarName ? " v" : "") VarName ( GLabel ? " g" : "") GLabel

  LB_CreateControl(GuiID, Type, Pos " " Options, Content)

  ;read control options, that can only be applied after creation and react on them

  If (Type = "Tab"){
    IniRead, TabPageList, %File%, Control %CtrlNumber%, TabPageList, %A_Space%
    Loop, Parse, TabPageList, |, A_Space
        LB_ReadTabPage(File, GuiID, A_Index, A_LoopField)
    Gui,%GuiID%:Tab
  }
}

;function to populate a tab page
LB_ReadTabPage(File, GuiID, TabID, TabPageNumber ){
  IniRead, ListOfCtrl, %File%, TabPage %TabPageNumber%, ListOfCtrl, %A_Space%
  Loop, Parse, ListOfCtrl, |, A_Space
  {
     Gui,%GuiID%:Tab, %TabID%
     LB_ReadControl(File, GuiID, A_LoopField)
  }

}

;function to set a specific var as global
LB_SetVarGlobal(VarName, VarValue){
  global
  %VarName% = %VarValue%
}

;create a control in a global context
LB_CreateControl(GuiID, Type, Options, Content){
  global
  Gui, %GuiID%:Add, %Type%, %Options%, %Content%
}

LB_Anchor(c, a = "", r = false) { ; v3.6 - Titan
	static d
	GuiControlGet, p, Pos, %c%
	If ex := ErrorLevel {
		Gui, %A_Gui%:+LastFound
		ControlGetPos, px, py, pw, ph, %c%
	}
	If !(A_Gui or px) and a
		Return
	i = x.w.y.h./.7.%A_GuiWidth%.%A_GuiHeight%.`n%A_Gui%:%c%=
	StringSplit, i, i, .
	d := a ? d . ((n := !InStr(d, i9)) ? i9 : "")
		: RegExReplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
	Loop, 4
		x := A_Index, j := i%x%, i6 += x = 3
		, k := !RegExMatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
		, e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
		, RegExMatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
		, l .= p%j% := InStr(a, j) ? (ex ? "" : j) . v1 + i%i6% * k : ""
	If r
		rx = Draw
	If ex
		ControlMove, %c%, px, py, pw, ph
	Else GuiControl, Move%rx%, %c%, %l%
}
