;###############################################################################
/* Messages for LilBuilder

*/
;###############################################################################

;activate/deactivate message handlers for script
Messages_SetHandlers( pFlag ) {
  static WM_LBUTTONDOWN   := 0x201
       , WM_LBUTTONUP     := 0x202
       , WM_LBUTTONDBLCLK := 0x203
       , WM_RBUTTONDOWN   := 0x204
       , WM_RBUTTONUP     := 0x205
       , WM_RBUTTONDBLCLK := 0x206
       , WM_MBUTTONDOWN   := 0x207
       , WM_MBUTTONUP     := 0x208
       , WM_MBUTTONDBLCLK := 0x209
       , WM_MOUSEWHEEL    := 0x20A
       , WM_MOUSEMOVE     := 0x200
       , WM_SYSCOMMAND    := 0x112
       , WM_PAINT         := 0x0F
       , WM_MOVING        := 0x216 

  If pFlag {
    OnMessage(WM_LBUTTONDOWN,     "Messages_OnLButtonDown")
;     OnMessage(WM_LBUTTONUP,       "Messages_OnLButtonUp")
;     OnMessage(WM_LBUTTONDBLCLK,   "Messages_OnLButtonDBLCLK")
    OnMessage(WM_RBUTTONDOWN,     "Messages_OnRButtonDown")
;     OnMessage(WM_RBUTTONUP,       "Messages_OnRButtonUp")
;     OnMessage(WM_RBUTTONDBLCLK,   "Messages_OnRButtonDBLCLK")
;     OnMessage(WM_MBUTTONDOWN,     "Messages_OnMButtonDown")
;     OnMessage(WM_MBUTTONUP,       "Messages_OnMButtonUp")
;     OnMessage(WM_MBUTTONDBLCLK,   "Messages_OnMButtonDBLCLK")
;     OnMessage(WM_MOUSEWHEEL,      "Messages_OnMouseWheel")
    OnMessage(WM_MOUSEMOVE,       "Messages_OnMouseMove")
;     OnMessage(WM_SYSCOMMAND,      "Messages_OnSysCommand")
;     OnMessage(WM_PAINT,           "Messages_OnPaint")
    OnMessage( WM_MOVING,         "Messages_OnMove")
  } Else {
    OnMessage(WM_LBUTTONDOWN,     "")
;     OnMessage(WM_LBUTTONUP,       "")
;     OnMessage(WM_LBUTTONDBLCLK,   "")
    OnMessage(WM_RBUTTONDOWN,     "")
;     OnMessage(WM_RBUTTONUP,       "")
;     OnMessage(WM_RBUTTONDBLCLK,   "")
;     OnMessage(WM_MBUTTONDOWN,     "")
;     OnMessage(WM_MBUTTONUP,       "")
;     OnMessage(WM_MBUTTONDBLCLK,   "")
;     OnMessage(WM_MOUSEWHEEL,      "")
    OnMessage(WM_MOUSEMOVE,       "")
;     OnMessage(WM_SYSCOMMAND,      "")
;     OnMessage(WM_PAINT,           "")
    OnMessage( WM_MOVING,         "")
  }
}

;select a control or drag a frame with LButton DOWN
Messages_OnLButtonDown(wparam, lparam, msg, hwnd){
   ha := 0 + DllCall("GetAncestor", "uint", hwnd, "uint", 2)   ;get gui handle [ GA_ROOT ]
   if Project_IsUserGUI(ha) {
      Selector_Size(False)                          ;disable resize function of selector
      Selector_vGuiHWND(ha)                         ;set selected gui 
      MouseGetPos, mX,mY,, hCtrl, 2
      If hCtrl {
         CtrlHwnd := 0 + TopChild(ha, 0 + hCtrl)
         If GetKeyState("LControl") {
           Selector_vCtrlHWND(CtrlHwnd)                    ;add current control to multiselection
         }Else{
           Selector_vCtrlHWND("No")                      ;clear selection
           Selector_vCtrlHWND(CtrlHwnd)                  ;set selected control
         }
         Selector_Set2Ctrl()
         ToolTip_ShowTips4Pos()
         Sleep, 10
         Selector_Size(True)                              ;enable resize function of selector
      }
      Else{
         Messages_SetHandlers( False )                    ;for the time of the frame drag disable all message handlers
         Selector_vCtrlHWND("No")                        ;clear selection
         ToolTip_ShowTips4Pos("Hide")
         Selector_DragFrameDraw(mX, mY)                   ;set initial frame coords
         Selector_Set2PosSize(mX, mY)                     ;show selector at position
         Grid_Draw(ha)
         SetTimer, Selector_DragFrame, 10                 ;drag frame with timer, IMO the robustes way
      }
      return 0                                      ;intercept click on user guis
   }
}
TopChild(pParent, h) {       ;since controls may consist of multiple HWND, e.g. combobox, get the top most
   loop {
      hp := 0 + DllCall("GetParent", "uint", h)
      if (hp=pParent) or !hp
         return h
      h := hp
   }
}

;show context menus
Messages_OnRButtonDown(wparam, lparam, msg, hwnd){
  MouseGetPos, X, Y, GuiHWND, CtrlHWND, 2
  Menu_vX(X)                                    ;store menu coordinates
  Menu_vY(Y)
  if (hwnd = Selector_vHWND()){                 ;menu for selector
    Menu_vGuiHWND(Selector_vGuiHWND())               ;set selected gui
    Menu_vCtrlHWND(Selector_vCtrlHWND())
    If InStr(Selector_vCtrlHWND(),"|")
      GoSub, MultiSelection_ShowMenu
    Else
      Messages_ShowMenu(Selector_vCtrlHWND())
  }
  Else If Project_IsUserGUI(0 + GuiHWND){       ;menu for user guis
    Selector_vCtrlHWND("No")                        ;clear selection
    Selector_Set2PosSize(-10, -10)                   ;hide selector
    ToolTip_ShowTips4Pos("Hide")
    Menu_vGuiHWND(GuiHWND + 0)                       ;set selected gui
    If CtrlHWND {
        CtrlHwnd := 0 + TopChild(GuiHWND, 0 + CtrlHWND)
        Menu_vCtrlHWND(CtrlHWND)                        ;set selected control
        Messages_ShowMenu(CtrlHWND)
    }
    Else
        GoSub, Gui_ShowMenu
  }
  Else If (hwnd = Toolbox_vHWND()){              ;menu for toolbox
     CtrlHwnd := 0 + TopChild(GuiHWND, 0 + CtrlHWND)
     Menu_vCtrlHWND(CtrlHWND)                           ;set selected control
     GoSub, Toolbox_ShowMenu
  }
}
;show menu depending on type of selected control
Messages_ShowMenu(CtrlHWND){
  If !(Type := Control(CtrlHWND, "Type"))  ;do nothing if type is unkown
    Return
  Label = %Type%_ShowMenu                  ;get menu Show Label
  If IsLabel(Label)                        ;if it exists
      GoSub, %Label%                           ;show menu
}

;move selector with mouse move as long as LButton is down
Messages_OnMouseMove(wparam, lparam, msg, hwnd) {
   if (hwnd = Selector_vHWND() and GetKeyState("LButton")){
    If ToolTip_ShowTips4Pos("ReturnState")
        Settimer, ToolTip_ShowTips4Pos, 50
    SendMessage, 0x112,0xF012,0,,% "ahk_id " hwnd ; [ WM_SYSCOMMAND, SC_MOVE ]

    If (GRID(Selector_vGuiHWND()) AND !GetKeyState("LControl")){   ;when GRID
      If InStr(Selector_vCtrlHWND(),"|"){            ;when multi selection
        Selector_Set2Grid()                                 ;snap selector pos to grid
        Selector_MoveCtrl2Selector()                        ;update controls to new selector position
      }
      Else If Selector_vCtrlHWND(){                 ;when single selection
        Selector_MoveCtrl2SelectorWGrid("PositionOnly")     ;update control to new grid position
        GoSub, Selector_UpdateSet2PosAfterSize              ;update selector pos to new control position
      }
    }                                             ;when NOT grid
    else Selector_MoveCtrl2Selector()                       ;update controls to new selector position
    Settimer, ToolTip_ShowTips4Pos, Off
  }
}

Messages_OnMove(wparam, lparam, msg, hwnd) {
  If Project_IsUserGUI(0 + hwnd){
    Selector_vGuiHWND(0 + hwnd)
    Selector_vCtrlHWND("No")                         ;clear selection
    Selector_Set2PosSize(-10, -10)                   ;hide selector
    ToolTip_ShowTips4Pos("Hide")
  }
}

;??? need to monitor minimization, to clear Selector_vGuiHWND() and selection
;??? need to monitor maximazation, to clear selection

; Messages_OnLButtonUp(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

; Messages_OnLButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

; Messages_OnRButtonUp(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnRButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonDown(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonUp(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMouseWheel(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

; Messages_OnSysCommand(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnPaint(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

