;###############################################################################
/* SaveLoad for LilBuilder

*/
;###############################################################################

SaveLoad_ExportProject(){
  ;??? ideas:
  ;specify defaults: path, file name, extension, only ini
  ;options for: Run, export as real script
  ;make include functions as extra file
  ;add anchor to functions
  
	FileSelectFile, OutFile, S16, GuiScript.ahk, Save Project as Script, AutoHotkey Script (*.ahk)
	If !OutFile
    Return
  OutFile .= RegExMatch(OutFile, "i)\.ahk$") ? "" : ".ahk"
  SplitPath, OutFile, , OutDir, , OutNameNoExt,
  ProjFile = %OutDir%\%OutNameNoExt%.lbp
	FileDelete, %OutFile%
  FileDelete, %ProjFile%

	ProjPNames := Project("AllPropertyNames")
	Loop, Parse, ProjPNames, `n
	{
		%A_LoopField% := Project(A_LoopField)
		CurrProp := %A_LoopField%
		If (A_LoopField != "ListOfGuiHWND" AND InStr(A_LoopField,"_") != 1)
			IniWrite, %CurrProp%, %ProjFile%, Project, %A_LoopField%
	}

  IniWrite, %A_Space% , %ProjFile%, Project, ListOfGuiID  ;create empty, to make sure this is the first in ini file
	Loop, Parse, ListOfGuiHWND, |
    ListOfGuiID .= "|" SaveLoad_ExportGui(ProjFile, A_LoopField)
	StringTrimLeft, ListOfGuiID, ListOfGuiID, 1
	IniWrite, %ListOfGuiID%, %ProjFile%, Project, ListOfGuiID

	SaveLoad_FinalScript(OutFile, ProjFile)
; 	Run, %OutFile%
}

SaveLoad_ExportGui(ProjFile, GuiHWND){
  SysGet_GuiFrameSizes(Gui(GuiHWND,"Toolwindow"), XFrame, YFrame, HCaption)
  FinalGuiID := Gui(GuiHWND,"_FinalGuiID")

	WinGetPos, X, Y, W, H, ahk_id %GuiHWND%
	;write gui size and pos info
	W -= 2 * XFrame
	H -= 2 * YFrame + HCaption
	IniWrite, x%X% y%Y% w%W% h%H%, %ProjFile%, Gui %FinalGuiID%, PosSize

  GuiPNames := Gui(GuiHWND,"AllPropertyNames")
  Loop, Parse, GuiPNames, `n
  {
  	%A_LoopField% := Gui(GuiHWND, A_LoopField)
  	CurrProp := %A_LoopField%

    If A_LoopField in OrderOfControls,GuiID
      Continue
    If InStr(A_LoopField,"_") = 1
      Continue

		IniWrite, %CurrProp%, %ProjFile%, Gui %FinalGuiID%, %A_LoopField%
	}

	CtrlCnt = 0
	Loop, Parse, OrderOfControls, |
    If ("Statusbar" != Control(A_LoopField, "Type") OR Gui(GuiHWND, "_StatusBar") > 0 )
      ListOfCtrl .= "|" SaveLoad_ExportControl(ProjFile, GuiHWND, CtrlCnt, A_LoopField, XFrame, YFrame + HCaption)
	StringTrimLeft, ListOfCtrl, ListOfCtrl, 1
	IniWrite, %ListOfCtrl%, %ProjFile%, Gui %FinalGuiID%, OrderOfControls

  Return FinalGuiID
}

SaveLoad_ExportControl(ProjFile, GuiHWND, ByRef CtrlCnt, CtrlHWND, XOffset, YOffset){
  CtrlCnt++
  ThisControlCnt = %CtrlCnt%
  
	CtrlPNames := Control(CtrlHWND,"AllPropertyNames")
	Loop, Parse, CtrlPNames, `n
	{
		%A_LoopField% := Control(CtrlHWND, A_LoopField)
		CurrProp := %A_LoopField%

    If A_LoopField in BelongsTo,VarName
      Continue
    If InStr(A_LoopField,"_") = 1
      Continue

    If ((A_LoopField = "AnchorValue" AND InStr(Gui(GuiHWND, "_AnchoredCtrls"),CtrlHWND)))
			IniWrite, %CurrProp%, %ProjFile%, Control %CtrlCnt%, %A_LoopField%
		Else
      IniWrite, %CurrProp%, %ProjFile%, Control %CtrlCnt%, %A_LoopField%
	}

  IniWrite, %_FinalVarName%, %ProjFile%, Control %CtrlCnt%, VarName
  
  If (Type != "StatusBar"){ 
  	ControlGetPos, X, Y, W, H,, ahk_id %CtrlHWND%
  	X -= XOffset
  	Y -= YOffset
  	IniWrite, x%X% y%Y% w%W% h%H%, %ProjFile%, Control %CtrlCnt%, PosSize
  }

  If (Type = "Tab"){
  	Loop, Parse, Content, |
    {
      CtrlCnt++
      ThisTabPageControlCnt = %CtrlCnt%
      OrderOfTabPageControls .= "|" CtrlCnt

      IniWrite, %A_Space%, %ProjFile%, Tabpage %ThisTabPageControlCnt%, OrderOfControls  ;create empty, to make sure this is above tab page controls
      
      OrderOfControls := Control(CtrlHWND "T" A_Index, "OrderOfControls")
    	ListOfCtrl =
      Loop, Parse, OrderOfControls, |
          ListOfCtrl .= "|" SaveLoad_ExportControl(ProjFile, GuiHWND, CtrlCnt, A_LoopField, XOffset, YOffset)
      StringTrimLeft, ListOfCtrl, ListOfCtrl, 1
    	IniWrite, %ListOfCtrl%, %ProjFile%, Tabpage %ThisTabPageControlCnt%, OrderOfControls
    }
    StringTrimLeft, OrderOfTabPageControls, OrderOfTabPageControls, 1
    IniWrite, %OrderOfTabPageControls%, %ProjFile%, Control %ThisControlCnt%, OrderOfTabPageControls
  }

  Return ThisControlCnt
}

;###############################################################################

;Steal(copy) gui and open it as project
SaveLoad_StealImport(){
	Stealer(A_Temp "\Gui_Stealer.lbp")
	SaveLoad_ImportProject(A_Temp "\Gui_Stealer.lbp")
}

;###############################################################################

;function to import a project
SaveLoad_ImportProject(File = "", GuitoCreate = 0){
  ;??? ideas:
  ;specify defaults: path, file name, extension, only ini

	If !FileExist(File)	{
		FileSelectFile, File, 1,, Import a Lil' Builder Project File, Lil Builder Project File (*.lbp)
		If !FileExist(File)
        Return
	}

  ;read project options and react on them

  If !GuitoCreate {
     IniRead, ListOfGuiID, %File%, Project, ListOfGuiID, %A_Space%
     Loop, Parse, ListOfGuiID, |, A_Space
         SaveLoad_ImportGui(File, A_LoopField)
  }Else
     SaveLoad_ImportGui(File, GuitoCreate)
}

;function to import a gui
SaveLoad_ImportGui(File, FinalGuiID){
  ;create Gui
  Items2Read = Content|PosSize|GridSize
  Loop, Parse, Items2Read, |
    IniRead, %A_LoopField%, %File%, Gui %FinalGuiID%, %A_LoopField%, %A_Space%

  ShowOptions := PosSize . " Hide"
  GuiHWND := Gui_Create(FinalGuiID, Content, ShowOptions)
  GuiID := Gui(GuiHWND,"GuiID")       ;get internal GuiID

  ;apply props that can only be applied after creation

  ;read gui properties (e.g. toolwindow) and apply them
  Items2Read = Toolwindow 
  Loop, Parse, Items2Read, |
  {
    IniRead, Prop, %File%, Gui %FinalGuiID%, %A_LoopField%, %A_Space%
    If Prop {
        Gui, %GuiID%:+%A_LoopField%
        Gui(GuiHWND,A_LoopField,Prop)
    }
  }

  ;read gui properties (e.g. Resize) that only need to be read and stored
  Items2Read = Resize
  Loop, Parse, Items2Read, |
  {
    IniRead, Prop, %File%, Gui %FinalGuiID%, %A_LoopField%, %A_Space%
    If Prop
        Gui(GuiHWND,A_LoopField,Prop)
  }

  ;create controls
  IniRead, ListOfCtrl, %File%, Gui %FinalGuiID%, OrderOfControls, %A_Space%
  Loop, Parse, ListOfCtrl, |, A_Space
      SaveLoad_ImportControl(File, GuiHWND, A_LoopField)

  ;show gui
  Gui, %GuiID%:Show
  
  If GridSize {
    GRID(GuiHWND, GridSize)
    Grid_Draw(GuiHWND)
  }
}

;function to import a control
SaveLoad_ImportControl(File, GuiHWND, CtrlNumber){
  IniRead, Type, %File%, Control %CtrlNumber%, Type, %A_Space%

  ;read control options (e.g. Font) and react on them
  
  Items2Read = Content|VarName|Options|PosSize|AnchorValue
  Loop, Parse, Items2Read, |
     IniRead, %A_LoopField%, %File%, Control %CtrlNumber%, %A_LoopField%, %A_Space%
  
  AddOptions := PosSize " " Options
  CtrlHWND := Control_CreateNew(Type, GuiHWND, Content, AddOptions)

  If AnchorValue {
    Control(CtrlHWND,"AnchorValue", AnchorValue)
    AnchoredCtrls := Gui(GuiHWND, "_AnchoredCtrls") . "|" . CtrlHWND
    If (InStr(AnchoredCtrls,"|") = 1)
      StringTrimLeft, AnchoredCtrls, AnchoredCtrls, 1
    Gui(GuiHWND, "_AnchoredCtrls", AnchoredCtrls)
  }

  ;apply control options, that can only be applied after creation and apply them

  ;store control options, that can not be applied
  Control(CtrlHWND,"_FinalVarName",VarName)

  If (Type = "Tab"){
    IniRead, OrderOfTabPageControls, %File%, Control %CtrlNumber%, OrderOfTabPageControls, %A_Space%
    Loop, Parse, OrderOfTabPageControls, |, A_Space
    {
      Tab_AddNewControlsToPage(GuiHWND, CtrlHWND, A_Index)
      IniRead, ListOfCtrl, %File%, TabPage %A_LoopField%, OrderOfControls, %A_Space%
      Loop, Parse, ListOfCtrl, |, A_Space
         SaveLoad_ImportControl(File, GuiHWND, A_LoopField)
    }
    Tab_AddNewControlsToPage(GuiHWND, "")
  }
}

;###############################################################################

SaveLoad_FinalScript(OutFile, ProjFile){
  SplitPath, ProjFile, ProjFileName, ProjFileDir, , ProjFileNameNoExt
  IncludeFunctions := ProjFileDir "\" ProjFileNameNoExt ".lbf"
  FileCopy, inc\LB_IncludeFunctions.ahk, %IncludeFunctions%, 1
  
  StartScript =
    (LTrim	
      #Include `%A_ScriptDir`%
      #Include %ProjFileNameNoExt%.lbf
      SetWorkingDir, `%A_ScriptDir`%
      
      ;LB_BuildGui("path_to_LBP_file"[, Gui_ID])
      ;if Gui_ID is not specified, all Guis in project are built
      LB_BuildGui("%ProjFileName%")   ;as single function call
      ;ListVars                                    ;to test global vars of GUI
      Return
    )
  FileAppend, %StartScript%`n`n, %OutFile%
  
	ListOfGuiHWND := Project("ListOfGuiHWND")
	Loop, Parse, ListOfGuiHWND, |
	{
    GuiID := Gui(A_LoopField, "_FinalGuiID")

    If !(GuiLabel := Gui(A_LoopField, "Label"))
      GuiLabel := (GuiID != 1 ? GuiID : "") "Gui"
    
    CloseScript .= GuiLabel "Close:`n"
    
    If (ListOfCtrlWHND := Gui(A_LoopField, "_AnchoredCtrls")){
      GuiID := Gui(A_LoopField, "GuiID")
      AchorScript .= GuiLabel "Size:`n"
      Loop, Parse, ListOfCtrlWHND, |, A_Space
        {
          CtrlID := Control(A_LoopField, "VarName")
          AnchorValue := Control(A_LoopField, "AnchorValue")
          AchorScript .= A_Tab "LB_Anchor( """ CtrlID """, """ AnchorValue """)`n"
        }
      AchorScript .= "Return`n`n"
    }
  }
  CloseScript .= A_Tab "ExitApp:`nReturn`n`n"
  FileAppend, %CloseScript%, %OutFile%
  FileAppend, %AchorScript%, %OutFile%
}
